;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunesCleanup, base

;called when the widget dies

widget_control, base, get_uvalue=object
if obj_valid(object) then obj_destroy, object

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes_event, event

widget_control, event.top, get_uvalue=object
;method names are stored as a uname
method = widget_info(event.id,/uname)
if method ne '' then begin
  call_method,method, object, event
endif

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::timerEvent, event

;if timer is off then don't retrigger it
if self.timer eq 0 then return

;if the stream is done playing then go to the next one
if self.oKRSaudiere->isPlaying() eq 0 then begin
  self->forward, fail=fail
  if fail eq 1 then return ;means no more songs
endif
;reset the timer
widget_control, event.id, timer=self.timer

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::rewind, event

widget_control, event.id, set_button=0
self.oKRSaudiere->rewind

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::forward, event, fail=fail

if n_params() eq 1 then widget_control, event.id, set_button=0
self.oKRSaudiere->stop ;clears the buffer

;load the new file
fail=0
if self.index ge n_elements(*self.pFiles) then begin
  void = dialog_message('End of Songs!', dialog_parent=self.wBase)
  fail=1
  widget_control, self.wBase, /destroy
  return
endif

;check to see if the file exists
if file_test((*self.pFiles)[self.index]) eq 0 then begin
  void = dialog_message((*self.pFiles)[self.index] + ' Not Found!', dialog_parent=self.wBase)
  fail=1
  widget_control, self.wBase, /destroy
  return
endif

self.oKRSaudiere->loadFile,(*self.pFiles)[self.index++], artist=artist, title=title, album=album
self->updateInfo, artist, title, album

;if we have no timer ready to go and we have stopped then we want to 
;start playing the next song
if self.timer eq 0 and self.stopped eq 1 then begin
  wId = widget_info(event.top, find_by_uname='play')
  widget_control, wId, set_value=self.path+'pause.bmp',/bitmap
  widget_control, wId, set_uname='pause', set_button=0
  self.stopped = 0
  widget_control, self.wBase,/clear
  self.oKRSaudiere->play
  self.timer = 2
  widget_control, self.wBase, timer=self.timer
endif else if self.timer ne 0 and self.stopped eq 0 then begin
  ;this path for when we are playing a song and the end is reached, we automatically play
  self.oKRSaudiere->play
endif

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::pause, event

widget_control, event.id, set_value=self.path+'play.bmp',/bitmap
widget_control, event.id, set_uname='play'
widget_control, event.id, set_button=0
;only pause if we are playing
if self.oKRSaudiere->isPlaying() eq 1 then self.oKRSaudiere->pause
self.timer = 0
self.stopped = 1

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::stop, event
;not used right now, but would be if we had a stop button
widget_control, event.id, set_button=0
if self.oKRSaudiere->isPlaying() eq 1 then self.oKRSaudiere->stop

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::play, event

widget_control, event.id, set_value=self.path+'pause.bmp',/bitmap
widget_control, event.id, set_uname='pause', set_button=0
self.stopped = 0 ;set the flag
self.oKRSaudiere->resume ;starts playing where we left off
if self.timer eq 0 then begin
  self.timer = 2
  widget_control, self.wBase, timer=self.timer
endif

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::updateInfo, artist, title, album

if artist eq 'Unknown' and title eq 'Unknown' and album eq 'Unknown' then begin
  textCrawl = (*self.pFiles)[(self.index-1) > 0]
endif else begin
  textCrawl = strcompress(title + ',' + artist + ',' + album + ';')
endelse
  
widget_control, widget_info(self.wBase, find_by_uname='wText'), $
                set_value=textCrawl

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes::cleanup

;update initialization file with the last file played
if self.index lt n_elements(*self.pFiles) then begin
  tempDir = filepath(/tmp,'')
  lastFile = (*self.pFiles)[--self.index]
  openw,lun,/get,tempDir+'idltunes.ini',/append
  printf,lun,lastFile
  free_lun,lun
endif

obj_destroy, self.oContainer
ptr_free, self.pFiles

return & end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

function IDLtunes::init, wBase, dir, lastFile, smallIcons=smallIcons, $
                        vertical=vertical, random=random

if keyword_set(vertical) then begin
  row = 0
  column = 1
endif else begin
  row = 1
  column = 0
endelse

;find the place where the icons are
path = sourceroot()
self.path = path ;save the path
;if we want small icons then change the path a little
if keyword_set(smallIcons) then begin
  path = path + 'small_'
endif
  
base = widget_base(/column, title='WORKING', tlb_frame_att=8)
void = widget_label(base,value=' ')
void = widget_label(base,value='Searching Directory and Building Music List')
void = widget_label(base,value=' ')
widget_control, base,/realize
widget_control, hourglass=1
;no spaces in the recurse pattern list!
;these are the files that Audiere can play
files = file_search(dir,'{*.wav,*.ogg,*.flac,*.mp3,*.mod,*.aiff,*.speex}',count=count)
if keyword_set(random) then begin ;mix up the songs
  indices = sort(randomu(seed,count))
  files = files[indices]
endif

widget_control, base,/destroy

if count eq 0 then begin
  void = dialog_message(['No Audio files found!', $
        'Does the directory have special characters like [ or ]?'],  /error)
  return,0
endif

widget_control, hourglass=0

if lastFile eq '' then begin ;no saved last file
  self.index = 0
endif else begin
  self.index = where( files eq lastFile, count)
  if count eq 0 then self.index = 0 ;if at the end then start over
endelse

self.pFiles = ptr_new(files) ;save the file names
 
wBase = widget_base(title='IDL tunes - With Apologies to Steve Jobs', column=1, uname='timerEvent')
wTextCrawl = krsTextCrawl(wBase, value='', uname='wText')
wRowBase = widget_base(wBase, /exclusive, row=row, column=column)
void = widget_button(wRowBase,value=path+'rewind.bmp',/bitmap, uname='rewind',/no_release)
void = widget_button(wRowBase,value=path+'pause.bmp',/bitmap, uname='pause',/no_release)
;dont need a stop button
;void = widget_button(wRowBase,value=path+'stop.bmp',/bitmap, uname='stop',/no_release)
wLast = widget_button(wRowBase,value=path+'forward.bmp',/bitmap,uname='forward',/no_release)

widget_control, wBase, /realize

;make the text crawling widget as small as possible
geom = widget_info(wLast ,/geom)
if keyword_set(vertical) then begin
  widget_control, wTextCrawl, scr_xsize=geom.xsize
endif else begin
    widget_control, wTextCrawl, scr_xsize=geom.xsize * 3
endelse
  
widget_control, wBase, set_uvalue=self, timer=2.0
self.wBase = wBase

;interface to the audiere object
self.oKRSaudiere = obj_new('KRSaudiere', files[self.index], artist=artist, title=title, album=album)

self->updateInfo, artist, title, album
self.oKRSaudiere->play ;start playing right away
self.timer = 2
self.index++

self.oContainer = obj_new('IDL_container')
self.oContainer->add, self.oKRSaudiere

return,1
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes__define

void = {IDLtunes, $
        
        path : '', $
        index : 0, $
        timer : 0.0, $
        stopped : 0, $
        
        pFiles : ptr_new(), $
        
        wBase : 0L, $
        
        oKRSaudiere : obj_new(), $
        oContainer : obj_new() }

return & end
        
;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro IDLtunes, _extra=extra

tempDir = filepath(/tmp,'')
path = ''
lastFile = ''
;check to see where we were last time
if file_test(tempDir+'idltunes.ini') eq 1 then begin
  openr,lun,/get,tempDir+'idltunes.ini'
  readf,lun,path
  if not eof(lun) then readf,lun, lastFile
  free_lun,lun
endif

if lastFile ne '' then begin
  yorn = dialog_message('Start playing with your last song?',/question)
  dir = path
endif else yorn = 'No'
if yorn eq 'No' then begin
  dir = dialog_pickfile(title='Choose top level directory with music files',/directory,path=path)
  if dir eq '' then return
  lastFile = ''
endif

;update it
openw,lun,/get,tempDir+'idltunes.ini'
printf,lun,dir
free_lun,lun

oIDLtune = obj_new('IDLtunes',wBase, dir, lastFile,  _extra=extra)
if obj_valid(oIDLtune) eq 0 then return

xmanager,'IDLtunes',wBase, /no_block, cleanup='IDLtunesCleanup'

return & end